\begin{algorithm}
\caption{Adaptive Push Pull Network Coding \label{algo4}}
\begin{algorithmic}[1]
  \State $k, ittl\gets ...$ \Comment{Push fanout and initial TTL}
  \State $ts, sm\gets ...$ \Comment{Trading window size and margin}
  \State $\Delta_{adjust}, {{}\Delta_{pull}}_{min}, {{}\Delta_{pull}}_{max} \gets ...$ \Comment{Periods config.}
  \State $\Delta_{pull}  \gets \Delta_{adjust}$ 
  \item[]

  \UponReceive{Push}{$ttl, T_q, p$}
    \State $ids \gets ids \cup T_q$
    \State $ \langle h, \_, \_ \rangle \gets p$

    \If{$\Call{ProcessPacket}{p}$} \label{line:stop_cond}
      \If{$ ttl > 0$}
        \State $\Call{SendToNeighbourgs}{h, ttl - 1}$
      \EndIf
    \EndIf
  \EndUponReceive
  \item[]

  \UponReceive{Pull}{$T_q, asked$}
    \State $ids \gets ids \cup T_q$
    \State $p \gets \varnothing$
    \If{$\exists\, g \in asked,\; \Call{Rank}{g,rcv} > 0$}
      \State $p \gets \Call{Recode}{g,rcv}$
    \EndIf
    \State $T_p \gets \Call{GetTradingWindow}$
    \State $\Call{Send}{\textsc{PullReply}, T_p, p}$
  \EndUponReceive
  \item[]

  \UponReceive{PullReply}{$T_q, p$}
    \State $ids \gets ids \cup T_q$
    \State $\Call{ProcessPacket}{p}$
  \EndUponReceive
  \item[]

  \Thread{every $\Delta_{pull}$}
    \State $ask \gets \Call{GetUncompleteGenerations}$
    \State $ids \gets \Call{rotate}{ids, 1}$
    \State $T_p \gets \Call{GetTradingWindow}{ }$
    \State $\Call{Send}{\textsc{Pull}, T_p, ask}$
  \EndThread
  \item[]

  \Thread{every $\Delta_{adjust}$}
    \State $missingSize \gets \Call{CountMissingPackets}$ 
    \label{line:compute-missing}
    \If{$missingSize > prevMissingSize$}
      \State $\Delta_{pull} = \frac{\Delta_{adjust}}{missingSize - prevMissingSize + prev_{useful}} $
    \ElsIf{$missingSize > 0 \land prev_{useless} \leq prev_{useful}$}
      \State $\Delta_{pull} \gets \Delta_{pull} \times 0.9$
    \Else
      \State $\Delta_{pull} \gets \Delta_{pull} \times 1.1$
    \EndIf
    \State $\Delta_{pull} \gets \Call{max}{\Delta_{pull}, {{}\Delta_{pull}}_{min}}$
    \State $\Delta_{pull} \gets \Call{min}{\Delta_{pull}, {{}\Delta_{pull}}_{max}}$
    \State $prev_{useless} \gets 0$
    \State $prev_{useful} \gets 0$
    \State $prevMissingSize \gets missingSize$
  \EndThread

\end{algorithmic}
\end{algorithm}


